#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="advertise.cgi";
require "utility.pl";
my $userId = CheckLogin($thisCGI);

&ReadFormData;	
$op = $formData{'op'};
if ($op eq "marketbyemail"){MarketByEmail();}
elsif ($op eq "sendmarketingemail"){SendMarketingEmail();}
elsif ($op eq "marketbyflyer"){MarketByFlyer();}
else {ShowMarketItems();}

sub ShowMarketItems{
# get the # of items the user has. 

Header("","Advertise","advertise");
	print qq[<br><table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr $s_loc_bar_bgcolor><td>
$s_loc_bar_font_s &nbsp; Advertise your books </td></tr>
<tr><td>$f
You can help sell your books faster by doing some of your own legwork. 
$siteName allows you to automatically create flyers and emails for you
to use in your advertising.
<br>
<br>
Select one of the options below.
<form name=flyerChoice method=post action="$thisCGI">
<b>A:</b> Advertise <a href="$thisCGI?op=marketbyemail">through email</a>
<br><br><b>B:</b> Advertise <a href="javascript:document.flyerChoice.submit()">through paper flyers</a>
<br>
<br>
<input type=hidden name=op value=marketbyflyer>
<table border=0><tr><td colspan=2>$f Options for flyer based marketing </td></tr>
<tr><td>$f 1.</td><td>$f Print books <select name=limit>
<option value=1>1-10
<option value=11>11-20
<option value=21>21-30
<option value=31>31-40
<option value=41>41-50
<option value=51>51-60
<option value=all>All
</select>
</td></tr>
<tr><td valign=top>$f 2.</td><td>$f
<input type=radio name=contactType value=system checked> Standard contact info
<br>
<input type=radio name=contactType value=custom> 
Create your own contact info $fe
<input type=text name=contactInfo size=30><br>
<input border=0 type=image src="$relImgDir/create_flyer.gif">

</td></tr></table>

</td></tr></table>
</form>


];
Footer();
}



sub SendMarketingEmail{

    Header("","Advertise","advertise");    
    
    my($firstName, $lastName, $email, $tel, $imType, $imIdentity, $zipcode, $username)=GetAllUserInfoByUserId($userId);
    $subject = $formData{'subject'};
    $emailList = $formData{'emaillist'};
    $message = $formData{'message'};
    
    # the user MUST have his own email address.
    if ($email eq ""){
	ErrorMsg("Please ensure you have a valid email address");
    }
    CheckErrors();
    
    # create the complete message
    $message .= "\n\n";
    $message .= GenerateEmailText();

    $ownerName = qq[$firstName $lastName];
    $ownerEmail = $email;
    
    print qq[<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr><td>$f];

    # limit the # of emails sent at one time to 25 to avoid spammers
    @sendto = split(',',$emailList);
    foreach $person (@sendto){
	if ($count++ > 25){exit;}
	print "<br>$count\. Sending email to $person";
	SendMail($ownerName, $ownerEmail, $person, $person, $subject, $message);	
    }
    
    AddTracking("ad_email_sent","$count");

    print qq[<br>Done.];
    print qq[</td></tr></table>];
    Footer();    
}


sub MarketByEmail{

    Header("","Advertise","advertise");    
    
    print qq[<br><table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
	     <form method=post action="$thisCGI">
	     <input type=hidden name=op value="sendmarketingemail">
	     <tr $s_loc_bar_bgcolor><td colspan=2>
	     $s_loc_bar_font_s &nbsp; Advertise through email</td></tr>
	     <tr><td colspan=2>$f Do some marketing to help sell your books faster.  </td></tr>
	     <tr>
	     <td>$f <b> Subject : </b> $fe</td>
	     <td><input type=text name=subject size=35 value="Textbooks for sale"></td>
	     </tr>
	     <tr>
	     <td>$f <b> Email List : </b> $fe</td>
	     <td><input type=text name=emaillist size=35> $f Enter comma seperated emails $fe</td>
	     </tr>
	     <tr>
	     <td>$f <b> Personal Message : </b> $fe</td>
	     <td width=350><textarea name=message rows=4 cols=40></textarea></td>
	     </tr>
	     <tr><td></td><td>$f <input type=submit value="Send mail"> </td></tr>
	     <tr><td colspan=2>$f 
	     the bottom text will automatically be included in your email.
	     <hr width=100% size=0><pre><font size=2 face=courier>];
    print GenerateEmailText();
    print qq[</td></tr>
	     </form>
	     </table>];
    &Footer;
    
}


sub GenerateEmailText {
    my ($emailText);
    my ($itemTable) = GetItemInventoryByUserId($userId);

    my($firstName, $lastName, $email, $tel, $imType, $imIdentity, $zipcode, $username)=GetAllUserInfoByUserId($userId);
    
    if ($tel ne ""){$tel = "or at $tel";}

    $numTextbooks = $#{$itemTable} + 1;
    $numTextbooks = "$numTextbooks textbook(s)";

    $emailText = qq[I currently have $numTextbooks for sale. 
To see my latest inventory of books, please go to 

$siteUrl$relCgiDir/search.cgi?op=s&st=username&q=$username

You can contact me at $email $tel 

The books currently available are listed below

];

    $emailText .= qq[                          Textbooks Forsale];
    $emailText .= qq[\n                          =================\n];
    my($i);

    for $i ( 0 .. $#{$itemTable} ) {
	$num = $i+1;
	$itemInventoryId= $itemTable->[$i][0];
	$itemInfoId = $itemTable->[$i][1];

	$course = $itemTable->[$i][4];
	$price = $itemTable->[$i][8];
	$title = $itemTable->[$i][5];
	$author = $itemTable->[$i][6];
	$edition = $itemTable->[$i][7];
	$isbn =  $itemTable->[$i][3];
	$condition = $conditionSet{$itemTable->[$i][9]};

	# get the book information for the particular book.
	my @bookData = GetItemInfoByItemInfoId($itemInfoId);
	$retailPrice = $bookData[3];
	if ($retailPrice ne ""){$retailText = "(Retail: \$$retailPrice)";}
	else{$retailText = "";}
	
	if ($author ne "") {$author = "by $author";}
	if ($edition eq "" || $edition == 0){$edition = "n/a";}
	if ($price !~ /\D/) {$price = "\$$price";}
	if ($num < 10){$num = " $num";}
    
	$emailText .=  qq[
$num. Course    : $course
    Title     : $title
    Author(s) : $author
    Edition   : $edition
    ISBN#     : $isbn

    Condition : $condition
    Ask Price : $price  $retailText

 ];
    }
$emailText .= qq[    
-------------------------------------------------------------------
Trying to sell your textbooks? Looking for a used textbook?
Go to $siteName! $siteUrl
-------------------------------------------------------------------
		     ];

    return $emailText;

}


sub MarketByFlyer{
    print qq[Content-type: text/html\n\n];
    $limit = $formData{'limit'};
    
    if ($limit == 1){$start = "0";}
    if ($limit == 11){$start = "10";}
    if ($limit == 21){$start = "20";}
    if ($limit == 31){$start = "30";}
    if ($limit == 41){$start = "40";}
    if ($limit == 51){$start = "50";}
    if ($limit eq "all"){$start = "";}

    my (@userInfo) = GetAllUserInfoByUserId($userId);
    $username = $userInfo[7];

    $contactType = $formData{'contactType'};
    $contactInfo = $formData{'contactInfo'};

    if ($contactType eq "custom"){
	$contactText= qq[$f $contactInfo];
    }else{
	$contactText= qq[$f url:<b>$domain</b><br> username: <b>$username</b>];
    }


    my ($itemTable) = GetItemInventoryByUserId($userId,$start,'10');

    # create the list of books for sale (10 to a page)
    $bookList = qq[<table border=0 cellpadding=4 cellspacing=3>];
    for $i ( 0 .. $#{$itemTable} ) {
	$num = $i + $limit;
	$course = $itemTable->[$i][4];
	$title  = $itemTable->[$i][5];
	$author  = $itemTable->[$i][6];
	$isbn  = $itemTable->[$i][3];
	$condition  = $conditionSet{$itemTable->[$i][9]};
	$price = $itemTable->[$i][8];

	$bookList .= qq[<tr><td valign=top>$f<b>$num\.</b></td>
			<td>$f<b>$course</b> <br>
			<u>$title</u><br>$author <br>
			\$$price
			<br> Condition: $condition
			$fe</td></tr>
			];
    }    
    $bookList .= qq[</table>];


    # create the tear outs (17 to a page...)
    $tearOut = qq[<table border=0 cellpadding=0 cellspacing=1>];
    if ($start eq ""){$maxTearOut = $#{$itemTable} * 1.7} 
    else {$maxTearOut = 17;}
    if ($maxTearOut < 17){$maxTearOut = 17;}
    for ($i=0; $i < $maxTearOut; $i++){
	$tearOut .= qq[<tr>
<td ><img src="$relImgDir/flyer_dot.gif" height=40 ></td>
<td>$contactText<br><img src="$relImgDir/bpix.gif" width=200 height=1>
 </td></tr>];
    }
    $tearOut .= qq[</table>];
    

    print qq[
<table border=0 cellpadding=0 cellspacing=0 width=100%><tr>
<td><img src="$relImgDir/logo.gif"></td>
<td valign=bottom><font size=+3 face=verdana><b><i>TEXTBOOKS FOR SALE!</i></b></font></td>
</tr>
<tr><td colspan=2 height=1><img src="$relImgDir/bpix.gif" width=100% height=1></td></tr></table>

<table border=0 cellpadding=0 cellspacing=0 width=100%>
<tr><td valign=top>$f
<!-- Information Column --><br>
I have the following books for sale. If interested, please visit <br>
<b>$siteName</b> and look up my books by <b> username: $username </b>
<br>
<br>
$bookList
</td><td valign=top align=right>
<!-- Tear Out Column -->
$tearOut
</td></tr>
</table>

];


}
